package edu.umd.cs.voting.view;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextArea;

import org.jdom.DataConversionException;
import org.jdom.Element;

import edu.umd.cs.voting.Controller;
import edu.umd.cs.voting.model.Candidate;
import edu.umd.cs.voting.model.Item;
import edu.umd.cs.voting.model.Page;

public class PartiesComponent extends JPanel implements ActionListener {
	
	protected Controller controller;
	
	public PartiesComponent(Element partiesElement, Controller controller) throws DataConversionException {
		super();

		this.controller = controller;
		
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		setSize(partiesElement.getAttribute("width").getIntValue(), partiesElement.getAttribute("height").getIntValue());
		invalidate();

		setBorder(BorderFactory.createLineBorder(Color.black, 3));
		
		Font partiesFont = Controller.readFontStyle(partiesElement);
		
		Element instructionsElement = partiesElement.getChild("instructions");
		String instructions = instructionsElement.getChild("p").getTextTrim();
			
		JTextArea lable = new JTextArea(instructions);
		lable.setLineWrap(true);
		lable.setEditable(false);
		lable.setWrapStyleWord(true);
		lable.setFont(Controller.readFontStyle(instructionsElement));
		add(lable);
		lable.setEnabled(false);
		lable.setDisabledTextColor(Color.black);
		lable.setCursor(controller.getCursor());

		int gridX = 0;
		int gridY = 1;
		
		JPanel buttonPanel = new JPanel(new GridLayout(0, 2));
		add(buttonPanel);
		
		Iterator i = partiesElement.getChildren("party").iterator();
		while (i.hasNext()) {
			Element each = (Element) i.next();
			String name = each.getAttributeValue("name");
			JButton button = new JButton(name);
			button.setFont(partiesFont);
			button.setMaximumSize(new Dimension(1000,1000));
			button.addActionListener(this);
			
			if (gridX > 1) {
				gridX = 0;
				gridY++;
			}
			
	        gridX++;
	        
			buttonPanel.add(button);
		}
		
		buttonPanel.getParent().validate();
		buttonPanel.invalidate();
	}

	public void actionPerformed(ActionEvent arg0) {
		String partyName = ((JButton)arg0.getSource()).getLabel();			
		Iterator pageIterator = controller.getBallot().getPages().iterator();
			
		while (pageIterator.hasNext()) {
			Page page = (Page) pageIterator.next();
			Iterator itemIterator = page.getItems().iterator();

			while (itemIterator.hasNext()) {								
				Item item = (Item) itemIterator.next();
				Iterator candidateIterator = item.getCandidates().iterator();
/*				boolean effected = false;
				
				while (candidateIterator.hasNext()) {
					Candidate candidate = (Candidate) candidateIterator.next();
					String candidateParty = candidate.getParty();
					if (candidateParty != null && candidateParty.equalsIgnoreCase(partyName)) {
						effected = true;
					}
				}								

				if (effected) {*/
					candidateIterator = item.getCandidates().iterator();
					while (candidateIterator.hasNext()) {
						Candidate candidate = (Candidate) candidateIterator.next();
						if (candidate.isSelected()) {
							candidate.getItem().unselect(candidate);
						}
					}

					candidateIterator = item.getCandidates().iterator();
					while (candidateIterator.hasNext()) {
						Candidate candidate = (Candidate) candidateIterator.next();
						String candidateParty = candidate.getParty();
						if (candidateParty != null && candidateParty.equalsIgnoreCase(partyName)) {
							item.select(candidate);
						}
					}
//				}
			}
		}
	}
}
