package edu.umd.cs.voting.view;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JTextField;

import edu.umd.cs.voting.Controller;

public class ScreenKeyboard extends JDialog implements ActionListener {

	protected JTextField text;
	protected JButton acceptButton;
	protected JButton cancelButton;
	protected CandidateNode candidate;
	
	public ScreenKeyboard(Controller controller, CandidateNode candidate) {
		super(controller, "Enter Write-In Candidate", true);
		this.candidate = candidate;
		JButton key;

		setCursor(controller.getCursor());
		
		Container c = getContentPane();
		GridBagLayout gridBag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();
		
		c.setLayout(gridBag);
		
		text = new JTextField();
		text.setCursor(controller.getCursor());

		if (candidate != null && !candidate.candidate.getName().equalsIgnoreCase("Write-In")) {
			text.setText(candidate.candidate.getName());
		}
		constraints.gridx = 0;
		constraints.gridy = 0;
		constraints.gridwidth = GridBagConstraints.REMAINDER;
		constraints.fill = GridBagConstraints.HORIZONTAL;
		gridBag.setConstraints(text, constraints);
		c.add(text);
		
		constraints.gridwidth = 1;

		// new row
//		constraints.gridy = 1;

/*		key = new JButton("1");
		key.addActionListener(this);
		constraints.gridx = 0;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("2");
		key.addActionListener(this);
		constraints.gridx = 1;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("3");
		key.addActionListener(this);
		constraints.gridx = 2;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("4");
		key.addActionListener(this);
		constraints.gridx = 3;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("5");
		key.addActionListener(this);
		constraints.gridx = 4;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("6");
		key.addActionListener(this);
		constraints.gridx = 5;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("7");
		key.addActionListener(this);
		constraints.gridx = 6;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("8");
		key.addActionListener(this);
		constraints.gridx = 7;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("9");
		key.addActionListener(this);
		constraints.gridx = 8;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("0");
		key.addActionListener(this);
		constraints.gridx = 9;
		gridBag.setConstraints(key, constraints);
		c.add(key);
*/

/*		key = new JButton("=");
		key.addActionListener(this);
		constraints.gridx = 11;
		gridBag.setConstraints(key, constraints);
		c.add(key);*/

		// new row
		constraints.gridy = 1;
		constraints.gridwidth = 1;
		
		key = new JButton("Q");
		key.addActionListener(this);
		constraints.gridx = 0;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("W");
		key.addActionListener(this);
		constraints.gridx = 1;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("E");
		key.addActionListener(this);
		constraints.gridx = 2;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("R");
		key.addActionListener(this);
		constraints.gridx = 3;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("T");
		key.addActionListener(this);
		constraints.gridx = 4;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("Y");
		key.addActionListener(this);
		constraints.gridx = 5;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("U");
		key.addActionListener(this);
		constraints.gridx = 6;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("I");
		key.addActionListener(this);
		constraints.gridx = 7;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("O");
		key.addActionListener(this);
		constraints.gridx = 8;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("P");
		key.addActionListener(this);
		constraints.gridx = 9;
		gridBag.setConstraints(key, constraints);
		c.add(key);
		
		key = new JButton("Back");
		key.addActionListener(this);
		constraints.gridx = 10;
		gridBag.setConstraints(key, constraints);
		c.add(key);
		
/*
		key = new JButton("[");
		key.addActionListener(this);
		constraints.gridx = 10;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("]");
		key.addActionListener(this);
		constraints.gridx = 11;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("/");
		key.addActionListener(this);
		constraints.gridx = 12;
		gridBag.setConstraints(key, constraints);
		c.add(key);
*/
		// new row
		constraints.gridy = 2;

		key = new JButton("A");
		key.addActionListener(this);
		constraints.gridx = 1;
		gridBag.setConstraints(key, constraints);
		c.add(key);
		
		key = new JButton("S");
		key.addActionListener(this);
		constraints.gridx = 2;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("D");
		key.addActionListener(this);
		constraints.gridx = 3;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("F");
		key.addActionListener(this);
		constraints.gridx = 4;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("G");
		key.addActionListener(this);
		constraints.gridx = 5;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("H");
		key.addActionListener(this);
		constraints.gridx = 6;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("J");
		key.addActionListener(this);
		constraints.gridx = 7;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("K");
		key.addActionListener(this);
		constraints.gridx = 8;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("L");
		key.addActionListener(this);
		constraints.gridx = 9;
		gridBag.setConstraints(key, constraints);
		c.add(key);
		
		key = new JButton("-");
		key.addActionListener(this);
		constraints.gridx = 10;
		gridBag.setConstraints(key, constraints);
		c.add(key);
		
/*
		key = new JButton(";");
		key.addActionListener(this);
		constraints.gridx = 10;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("'");
		key.addActionListener(this);
		constraints.gridx = 11;
		gridBag.setConstraints(key, constraints);
		c.add(key);
*/
		// new row
		constraints.gridy = 3;

		key = new JButton("Z");
		key.addActionListener(this);
		constraints.gridx = 2;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("X");
		key.addActionListener(this);
		constraints.gridx = 3;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("C");
		key.addActionListener(this);
		constraints.gridx = 4;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("V");
		key.addActionListener(this);
		constraints.gridx = 5;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("B");
		key.addActionListener(this);
		constraints.gridx = 6;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("N");
		key.addActionListener(this);
		constraints.gridx = 7;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		key = new JButton("M");
		key.addActionListener(this);
		constraints.gridx = 8;
		gridBag.setConstraints(key, constraints);
		c.add(key);

/*		key = new JButton(",");
		key.addActionListener(this);
		constraints.gridx = 9;
		gridBag.setConstraints(key, constraints);
		c.add(key);
*/
		key = new JButton(".");
		key.addActionListener(this);
		constraints.gridx = 10;
		gridBag.setConstraints(key, constraints);
		c.add(key);

/*		key = new JButton("/");
		key.addActionListener(this);
		constraints.gridx = 11;
		gridBag.setConstraints(key, constraints);
		c.add(key);
*/
		// new row
		constraints.gridy = 4;

		key = new JButton("Space");
		key.addActionListener(this);
		constraints.gridx = 2;
		constraints.gridwidth = 7;
		gridBag.setConstraints(key, constraints);
		c.add(key);

		// new row
		constraints.gridy = 5;

		JLabel lable = new JLabel("");
		constraints.gridx = 0;
		constraints.gridwidth = 10;
		gridBag.setConstraints(lable, constraints);
		c.add(lable);

		// new row
		constraints.gridy = 6;
		constraints.gridwidth = 5;

		acceptButton = new JButton("Record Write-In");
		constraints.gridx = 1;
		constraints.gridwidth = 4;
		gridBag.setConstraints(acceptButton, constraints);
		acceptButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ScreenKeyboard.this.setVisible(false);
				ScreenKeyboard.this.dispose();
				if (ScreenKeyboard.this.candidate != null) {
					ScreenKeyboard.this.candidate.setName(text.getText());
				}
			}
		});
		c.add(acceptButton);

		cancelButton = new JButton("Cancel");
		constraints.gridx = 6;
		constraints.gridwidth = 4;
		gridBag.setConstraints(cancelButton, constraints);
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ScreenKeyboard.this.setVisible(false);
				ScreenKeyboard.this.dispose();
			}
		});
		c.add(cancelButton);
		
		pack();
		setLocationRelativeTo(controller);
		validate();
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent e) {
		JButton b = (JButton) e.getSource();
		if (b.getText().equals("Back")) {
			if (text.getText().length() == 0) {
				Toolkit.getDefaultToolkit().beep();
			} else {
				text.setText(text.getText().substring(0, text.getText().length() - 1));
			}
		} else if (b.getText().equals("Space")) {
			text.setText(text.getText() + " ");
		} else {
			text.setText(text.getText() + b.getText());
		}
	}
	
	public static void main(String[] args) {
		new LowVisionMetalLookAndFeel(new ScreenKeyboard(null, null));
	}
}
