package edu.umd.cs.voting.model;

import org.jdom.Element;

import edu.umd.cs.piccolox.event.PNotificationCenter;

public class Candidate {

	public static final String SELECTED_STATE_CHANGED = "SELECTED_STATE_CHANGED";

	protected Item item;
	protected String name;
	protected String otherName;
	protected String party;
//	protected boolean isWriteIn;
	protected boolean isSelected;
	
	public Candidate(Item item, Element candidateElement) {
		this.item = item;
		name = candidateElement.getAttributeValue("name");
		otherName = candidateElement.getAttributeValue("otherName");
		party = candidateElement.getAttributeValue("party");

		if (name != null) name = name.replaceAll("@br", "\n");
		if (otherName != null) otherName = otherName.replaceAll("@br", "\n");
		//party = name.replaceAll("@br", "\n");

	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public String getName() {
		return name;
	}
	
	public String getOtherName() {
		return otherName;
	}
	
	public String getParty() {
		return party;
	}
	
	public Item getItem() {
		return item;
	}
	
	public boolean isSelected() {
		return isSelected;
	}
	
	public void setIsSelected(boolean selected) {
		isSelected = selected;
		PNotificationCenter.defaultCenter().postNotification(SELECTED_STATE_CHANGED, this);
	}
}
